Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PlushPushBenchmarkSuiteProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PlushPushBenchmarkSuiteProblem.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PlushPushBenchmarkSuiteProblem.cs	(revision 15289)
@@ -7,5 +7,8 @@
   using HeuristicLab.Problems.Instances;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Solution;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Solution.BenchmarkSuite;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IntegerVectorPushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IntegerVectorPushProblem.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IntegerVectorPushProblem.cs	(revision 15289)
@@ -4,11 +4,11 @@
   using Common;
   using Configuration;
-  using Core;
-  using HeuristicLab.Data;
   using HeuristicLab.Encodings.IntegerVectorEncoding;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Analyzer;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Individual;
   using HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator;
+
   using Optimization;
   using Persistence.Default.CompositeSerializers.Storable;
@@ -54,5 +54,4 @@
     //  IndividualMapper.Clear();
     //  RandomPool.Clear();
-    //  Config.Seed = 0;
     //}
 
@@ -81,27 +80,23 @@
     }
 
-    protected override PushProgram MapIndividual(Individual individual, IRandom random) {
-      var program = individual.ToPushProgram(Config, random);
+    protected override PushProgram MapIndividual(Individual individual) {
+      var program = individual.ToPushProgram(Config);
 
       return program;
     }
 
-    public override double Evaluate(Individual individual, IRandom random) {
-      // init seed of random pool
-      //Interlocked.CompareExchange(ref RandomPool.Seed, random.Next(), 0);
-      //Config.Seed = RandomPool.Seed;
+    //public override double Evaluate(Individual individual, IRandom random) {
+    //  var seed = random.Next();
 
-      //var rand = RandomPool.ResetAndAllocate();
-      var program = MapIndividual(individual, random);
-      //RandomPool.Free(rand);
+    //  var program = individual.ToPushProgram(Config);
 
-      //rand = RandomPool.ResetAndAllocate();
-      var result = PushEvaluator.EvaluateTraining(Pool, program, random);
-      //RandomPool.Free(rand);
+    //  var rand = new FastRandom(seed);
+    //  var result = PushEvaluator.EvaluateTraining(Pool, program, rand);
 
-      individual[CaseQualitiesScopeParameterName] = new DoubleArray(result.ExampleQualities);
+    //  individual[CaseQualitiesScopeParameterName] = new DoubleArray(result.ExampleQualities);
+    //  individual[SeedScopeParameterName] = new IntValue(seed);
 
-      return result.AvgQuality;
-    }
+    //  return result.AvgQuality;
+    //}
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PlushPushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PlushPushProblem.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PlushPushProblem.cs	(revision 15289)
@@ -9,4 +9,5 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Analyzer;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Encoding;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
 
@@ -43,5 +44,5 @@
     }
 
-    protected override PushProgram MapIndividual(Individual individual, IRandom random) {
+    protected override PushProgram MapIndividual(Individual individual) {
       var plushVector = individual.PlushVector();
       var program = plushVector.PushProgram;
@@ -49,13 +50,4 @@
       return program;
     }
-
-    public override double Evaluate(Individual individual, IRandom random) {
-      var program = MapIndividual(individual, random);
-      var result = PushEvaluator.EvaluateTraining(Pool, program, random);
-
-      individual[CaseQualitiesScopeParameterName] = new DoubleArray(result.ExampleQualities);
-
-      return result.AvgQuality;
-    }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblemBase.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblemBase.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblemBase.cs	(revision 15289)
@@ -10,7 +10,10 @@
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.ObjectPools.Random;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Solution;
+  using HeuristicLab.Random;
 
   [StorableClass]
@@ -31,4 +34,5 @@
     public const string CasesScopeParameterName = "CaseQualities";
     public const string CaseQualitiesScopeParameterName = "CaseQualities";
+    public const string SeedScopeParameterName = "Seed";
 
     protected PushProblemBase(IPushEvaluator evaluator) {
@@ -88,15 +92,19 @@
       var bestQuality = Maximization ? qualities.Max() : qualities.Min();
       var bestIdx = Array.IndexOf(qualities, bestQuality);
-      var program = MapIndividual(individuals[bestIdx], random);
+      var bestIndividual = individuals[bestIdx];
+      var seed = (IntValue)bestIndividual[SeedScopeParameterName];
+      var program = MapIndividual(bestIndividual);
 
-      var isIndividualBetter = AnalyzeBestTrainingSolution(program, bestQuality, results, random);
+      var rand = new FastRandom(seed.Value);
+      var isIndividualBetter = AnalyzeBestTrainingSolution(program, bestQuality, results, rand);
 
       if (isIndividualBetter) {
-        AnalyzeBestTestSolution(program, results, random);
+        rand.Reset(seed.Value);
+        AnalyzeBestTestSolution(program, results, rand);
       }
     }
 
     protected void AnalyzeBestTestSolution(PushProgram program, ResultCollection results, IRandom random) {
-      var testResult = PushEvaluator.EvaluateTraining(Pool, program, random);
+      var testResult = PushEvaluator.EvaluateTest(Pool, program, random);
 
       if (!results.ContainsKey(TEST_QUALITY_RESULT_NAME)) {
@@ -108,11 +116,11 @@
 
     protected bool AnalyzeBestTrainingSolution(PushProgram program, double bestQuality, ResultCollection results, IRandom random) {
-      if (!results.ContainsKey(BEST_TRAINING_SOLUTION_RESULT_NAME)) {
-        var solution = CreatePushSolution(
+      var solution = CreatePushSolution(
             program,
             bestQuality,
-            (IRandom)random.Clone(),
+            random, // is already cloned
             (IReadOnlyPushConfiguration)Config.Clone());
 
+      if (!results.ContainsKey(BEST_TRAINING_SOLUTION_RESULT_NAME)) {
         results.Add(new Result(BEST_TRAINING_SOLUTION_RESULT_NAME, solution));
         return true;
@@ -123,9 +131,5 @@
       if ((!Maximization && currentBestQuality > bestQuality) ||
            (Maximization && currentBestQuality < bestQuality)) {
-        results[BEST_TRAINING_SOLUTION_RESULT_NAME].Value = CreatePushSolution(
-            program,
-            bestQuality,
-            random,
-            Config);
+        results[BEST_TRAINING_SOLUTION_RESULT_NAME].Value = solution;
         return true;
       }
@@ -135,13 +139,16 @@
 
     public override double Evaluate(Individual individual, IRandom random) {
-      var program = MapIndividual(individual, random);
-      var result = PushEvaluator.EvaluateTraining(Pool, program, random);
+      var program = MapIndividual(individual);
+      var seed = random.Next();
+      var rand = new FastRandom(seed);
+      var result = PushEvaluator.EvaluateTraining(Pool, program, rand);
 
       individual[CaseQualitiesScopeParameterName] = new DoubleArray(result.ExampleQualities);
+      individual[SeedScopeParameterName] = new IntValue(seed);
 
       return result.AvgQuality;
     }
 
-    protected abstract PushProgram MapIndividual(Individual individual, IRandom random);
+    protected abstract PushProgram MapIndividual(Individual individual);
 
     protected abstract PushSolution CreatePushSolution(
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Selector/LexicaseSelector.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Selector/LexicaseSelector.cs	(revision 15288)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Selector/LexicaseSelector.cs	(revision 15289)
@@ -60,10 +60,23 @@
 
     protected override IScope[] Select(List<IScope> population) {
-      var count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
-      var copy = CopySelectedParameter.Value.Value;
-      var maximization = MaximizationParameter.ActualValue.Value;
-      var random = RandomParameter.ActualValue;
+      var selected = Apply(
+        population,
+        NumberOfSelectedSubScopesParameter.ActualValue.Value,
+        CopySelectedParameter.Value.Value,
+        MaximizationParameter.ActualValue.Value,
+        RandomParameter.ActualValue,
+        CaseQualitiesParameter.ActualValue);
+
+      return selected;
+    }
+
+    public static IScope[] Apply(
+      List<IScope> population,
+      int count,
+      bool copy,
+      bool maximization,
+      IRandom random,
+      ItemArray<DoubleArray> caseQualities) {
       var selected = new IScope[count];
-      var caseQualities = CaseQualitiesParameter.ActualValue;
       var repeats = (int)Math.Ceiling(count / (double)population.Count);
       var caseCount = caseQualities[0].Length;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/BenchmarkSuitePushSolutionView.Designer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/BenchmarkSuitePushSolutionView.Designer.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/BenchmarkSuitePushSolutionView.Designer.cs	(revision 15289)
@@ -0,0 +1,212 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Solution.BenchmarkSuite {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Views;
+
+  partial class BenchmarkSuitePushSolutionView {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (this.components != null)) {
+        this.components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.Windows.Forms.DataGridViewCellStyle dataGridViewCellStyle1 = new System.Windows.Forms.DataGridViewCellStyle();
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabPage1 = new System.Windows.Forms.TabPage();
+      this.exampleComboBox = new System.Windows.Forms.ComboBox();
+      this.label1 = new System.Windows.Forms.Label();
+      this.tabPage2 = new System.Windows.Forms.TabPage();
+      this.trainingResultsDataGrid = new System.Windows.Forms.DataGridView();
+      this.tabPage3 = new System.Windows.Forms.TabPage();
+      this.testResultsDataGrid = new System.Windows.Forms.DataGridView();
+      this.pushDebugger = new HeuristicLab.Problems.ProgramSynthesis.Push.Views.PushDebuggerView();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.tabControl.SuspendLayout();
+      this.tabPage1.SuspendLayout();
+      this.tabPage2.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.trainingResultsDataGrid)).BeginInit();
+      this.tabPage3.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.testResultsDataGrid)).BeginInit();
+      this.SuspendLayout();
+      //
+      // nameTextBox
+      //
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      this.nameTextBox.Size = new System.Drawing.Size(755, 20);
+      //
+      // infoLabel
+      //
+      this.infoLabel.Location = new System.Drawing.Point(838, 3);
+      //
+      // tabControl
+      //
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.tabPage1);
+      this.tabControl.Controls.Add(this.tabPage2);
+      this.tabControl.Controls.Add(this.tabPage3);
+      this.tabControl.Location = new System.Drawing.Point(6, 26);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(848, 602);
+      this.tabControl.TabIndex = 12;
+      //
+      // tabPage1
+      //
+      this.tabPage1.AutoScroll = true;
+      this.tabPage1.Controls.Add(this.pushDebugger);
+      this.tabPage1.Controls.Add(this.exampleComboBox);
+      this.tabPage1.Controls.Add(this.label1);
+      this.tabPage1.Location = new System.Drawing.Point(4, 22);
+      this.tabPage1.Name = "tabPage1";
+      this.tabPage1.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage1.Size = new System.Drawing.Size(840, 576);
+      this.tabPage1.TabIndex = 0;
+      this.tabPage1.Text = "Debug";
+      this.tabPage1.UseVisualStyleBackColor = true;
+      //
+      // exampleComboBox
+      //
+      this.exampleComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.exampleComboBox.FormattingEnabled = true;
+      this.exampleComboBox.Location = new System.Drawing.Point(58, 6);
+      this.exampleComboBox.Name = "exampleComboBox";
+      this.exampleComboBox.Size = new System.Drawing.Size(776, 21);
+      this.exampleComboBox.TabIndex = 11;
+      //
+      // label1
+      //
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(3, 9);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(50, 13);
+      this.label1.TabIndex = 10;
+      this.label1.Text = "Example:";
+      //
+      // tabPage2
+      //
+      this.tabPage2.Controls.Add(this.trainingResultsDataGrid);
+      this.tabPage2.Location = new System.Drawing.Point(4, 22);
+      this.tabPage2.Name = "tabPage2";
+      this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage2.Size = new System.Drawing.Size(840, 576);
+      this.tabPage2.TabIndex = 1;
+      this.tabPage2.Text = "Traning Results";
+      this.tabPage2.UseVisualStyleBackColor = true;
+      //
+      // trainingResultsDataGrid
+      //
+      this.trainingResultsDataGrid.AllowUserToAddRows = false;
+      this.trainingResultsDataGrid.AllowUserToDeleteRows = false;
+      this.trainingResultsDataGrid.AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode.AllCells;
+      this.trainingResultsDataGrid.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+      dataGridViewCellStyle1.Alignment = System.Windows.Forms.DataGridViewContentAlignment.MiddleLeft;
+      dataGridViewCellStyle1.BackColor = System.Drawing.SystemColors.Window;
+      dataGridViewCellStyle1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      dataGridViewCellStyle1.ForeColor = System.Drawing.SystemColors.ControlText;
+      dataGridViewCellStyle1.SelectionBackColor = System.Drawing.SystemColors.Highlight;
+      dataGridViewCellStyle1.SelectionForeColor = System.Drawing.SystemColors.HighlightText;
+      dataGridViewCellStyle1.WrapMode = System.Windows.Forms.DataGridViewTriState.True;
+      this.trainingResultsDataGrid.DefaultCellStyle = dataGridViewCellStyle1;
+      this.trainingResultsDataGrid.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.trainingResultsDataGrid.EditMode = System.Windows.Forms.DataGridViewEditMode.EditProgrammatically;
+      this.trainingResultsDataGrid.Location = new System.Drawing.Point(3, 3);
+      this.trainingResultsDataGrid.Name = "trainingResultsDataGrid";
+      this.trainingResultsDataGrid.ReadOnly = true;
+      this.trainingResultsDataGrid.RowHeadersWidthSizeMode = System.Windows.Forms.DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders;
+      this.trainingResultsDataGrid.Size = new System.Drawing.Size(834, 570);
+      this.trainingResultsDataGrid.TabIndex = 0;
+      //
+      // tabPage3
+      //
+      this.tabPage3.Controls.Add(this.testResultsDataGrid);
+      this.tabPage3.Location = new System.Drawing.Point(4, 22);
+      this.tabPage3.Name = "tabPage3";
+      this.tabPage3.Size = new System.Drawing.Size(840, 576);
+      this.tabPage3.TabIndex = 2;
+      this.tabPage3.Text = "Test Results";
+      this.tabPage3.UseVisualStyleBackColor = true;
+      //
+      // testResultsDataGrid
+      //
+      this.testResultsDataGrid.AllowUserToAddRows = false;
+      this.testResultsDataGrid.AllowUserToDeleteRows = false;
+      this.testResultsDataGrid.AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode.AllHeaders;
+      this.testResultsDataGrid.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+      this.testResultsDataGrid.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.testResultsDataGrid.EditMode = System.Windows.Forms.DataGridViewEditMode.EditProgrammatically;
+      this.testResultsDataGrid.Location = new System.Drawing.Point(0, 0);
+      this.testResultsDataGrid.Name = "testResultsDataGrid";
+      this.testResultsDataGrid.ReadOnly = true;
+      this.testResultsDataGrid.RowHeadersWidthSizeMode = System.Windows.Forms.DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders;
+      this.testResultsDataGrid.Size = new System.Drawing.Size(840, 576);
+      this.testResultsDataGrid.TabIndex = 1;
+      //
+      // pushDebugger
+      //
+      this.pushDebugger.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.pushDebugger.Caption = "View";
+      this.pushDebugger.Content = null;
+      this.pushDebugger.Location = new System.Drawing.Point(6, 33);
+      this.pushDebugger.Name = "pushDebugger";
+      this.pushDebugger.ReadOnly = false;
+      this.pushDebugger.Size = new System.Drawing.Size(831, 540);
+      this.pushDebugger.TabIndex = 12;
+      //
+      // BenchmarkSuitePushSolutionView
+      //
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tabControl);
+      this.Name = "BenchmarkSuitePushSolutionView";
+      this.Size = new System.Drawing.Size(857, 631);
+      this.Controls.SetChildIndex(this.tabControl, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.infoLabel, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.tabControl.ResumeLayout(false);
+      this.tabPage1.ResumeLayout(false);
+      this.tabPage1.PerformLayout();
+      this.tabPage2.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.trainingResultsDataGrid)).EndInit();
+      this.tabPage3.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.testResultsDataGrid)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage tabPage1;
+    private System.Windows.Forms.ComboBox exampleComboBox;
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.TabPage tabPage2;
+    private System.Windows.Forms.DataGridView trainingResultsDataGrid;
+    private PushDebuggerView pushDebugger;
+    private System.Windows.Forms.TabPage tabPage3;
+    private System.Windows.Forms.DataGridView testResultsDataGrid;
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15289)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Solution/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15289)
@@ -0,0 +1,231 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Solution.BenchmarkSuite {
+  using System;
+  using System.Drawing;
+  using System.Linq;
+  using System.Windows.Forms;
+
+  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Views;
+  using HeuristicLab.Common;
+  using HeuristicLab.Core.Views;
+  using HeuristicLab.MainForm;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Evaluator;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Solution;
+
+  [View("Push Program Debugger")]
+  [Content(typeof(PushSolution), true)]
+  public partial class BenchmarkSuitePushSolutionView : NamedItemView {
+
+    private const string Separator = ", ";
+
+    private const string exampleSplitter = " => ";
+    private const string AbsoluteDiffHeaderText = "Absolute Diff.";
+    private const string RelativeDiffHeaderText = "Relative Diff.";
+    private const string InputHeaderStringFormat = "Input {0} : {1}";
+    private const string EstimatedOutputHeaderStringFormat = "Expected Output {0} : {1}";
+    private const string OutputHeaderStringFormat = "Output {0} : {1}";
+    private static readonly Color correctExampleFontColor = Color.FromArgb(0x5cb85c);
+    private PooledPushInterpreter interpreter;
+    private PushInterpreterPool pool;
+
+    public BenchmarkSuitePushSolutionView() {
+      InitializeComponent();
+      Name = "Push Program Debugger";
+      InitEvents();
+    }
+
+    ~BenchmarkSuitePushSolutionView() {
+      interpreter.Dispose();
+    }
+
+    private void InitEvents() {
+      exampleComboBox.SelectedIndexChanged += SelectedExampleIndexChanged;
+      pushDebugger.OnReset += PushDebuggerReset;
+    }
+
+    private void PushDebuggerReset(object sender, IPushInterpreter interpreter) {
+      if (exampleComboBox.SelectedIndex < 0) return;
+
+      var example = Evaluator.Data.Examples[exampleComboBox.SelectedIndex];
+
+      interpreter.InitExample(example);
+    }
+
+    private void SelectedExampleIndexChanged(object sender, EventArgs e) {
+      pushDebugger.ResetDebugging();
+    }
+
+    public new PushBenchmarkSuiteSolution Content
+    {
+      get { return (PushBenchmarkSuiteSolution)base.Content; }
+      set
+      {
+        base.Content = value;
+      }
+    }
+
+    public PushBenchmarkSuiteEvaluator Evaluator
+    {
+      get { return (PushBenchmarkSuiteEvaluator)Content.Evaluator; }
+    }
+
+
+    protected override void OnContentChanged() {
+      if (Content == null) return;
+
+      Name = "Push Solution";
+      nameTextBox.Text = Name;
+
+      pool = new PushInterpreterPool(Content.Config);
+
+      if (interpreter != null) {
+        interpreter.Dispose();
+      }
+
+      var random = Content.GetRandom();
+      interpreter = pool.Create(random);
+      UpdateExamples(Evaluator.Data);
+
+      if (exampleComboBox.SelectedIndex < 0) {
+        exampleComboBox.SelectedIndex = 0; // Triggers ResetDebugging via event
+      }
+
+      InitResultGrid(trainingResultsDataGrid, Evaluator.DataBounds.TrainingRange.Start, Evaluator.DataBounds.TrainingRange.End);
+      InitResultGrid(testResultsDataGrid, Evaluator.DataBounds.TestRange.Start, Evaluator.DataBounds.TestRange.End);
+
+      pushDebugger.Content = Content;
+    }
+
+    private void InitResultGrid(DataGridView grid, int start, int end) {
+      grid.Columns.Clear();
+      grid.Rows.Clear();
+
+      var cellTemplate = new DataGridViewTextBoxCell { Style = { WrapMode = DataGridViewTriState.True } };
+      var data = Evaluator.Data;
+
+      for (var i = 0; i < data.InputArgumentTypes.Length; i++) {
+        var headerTypeName = ViewHelper.GetHeaderTypeName(data.InputArgumentTypes[i]);
+        var column = new DataGridViewColumn {
+          HeaderText = string.Format(InputHeaderStringFormat, i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate,
+          DefaultCellStyle = { Alignment = DataGridViewContentAlignment.MiddleRight },
+          SortMode = DataGridViewColumnSortMode.Automatic
+        };
+
+        grid.Columns.Add(column);
+      }
+
+      for (var i = 0; i < data.OutputArgumentTypes.Length; i++) {
+        var headerTypeName = ViewHelper.GetHeaderTypeName(data.OutputArgumentTypes[i]);
+
+        var estimatedOutputColumn = new DataGridViewColumn {
+          HeaderText = string.Format(EstimatedOutputHeaderStringFormat, i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate,
+          SortMode = DataGridViewColumnSortMode.Automatic
+        };
+
+        var outputColumn = new DataGridViewColumn {
+          HeaderText = string.Format(OutputHeaderStringFormat, i + 1, headerTypeName),
+          AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
+          CellTemplate = cellTemplate,
+          SortMode = DataGridViewColumnSortMode.Automatic
+        };
+
+        estimatedOutputColumn.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+        outputColumn.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+
+        grid.Columns.Add(estimatedOutputColumn);
+        grid.Columns.Add(outputColumn);
+      }
+
+      var absoluteDiffColumn = new DataGridViewColumn {
+        HeaderText = AbsoluteDiffHeaderText,
+        AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader,
+        CellTemplate = cellTemplate,
+        SortMode = DataGridViewColumnSortMode.Automatic
+      };
+
+      var relativeDiffColumn = new DataGridViewColumn {
+        HeaderText = RelativeDiffHeaderText,
+        AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader,
+        CellTemplate = cellTemplate,
+        SortMode = DataGridViewColumnSortMode.Automatic
+      };
+
+      absoluteDiffColumn.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+      relativeDiffColumn.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
+
+      grid.Columns.Add(absoluteDiffColumn);
+      grid.Columns.Add(relativeDiffColumn);
+
+      var random = Content.GetRandom();
+      using (var pushInterpreter = pool.Create(random)) {
+        var rowIndex = 1;
+        for (var i = start; i < end; i++, rowIndex++) {
+          var example = data.Examples[i];
+          var row = new DataGridViewRow {
+            HeaderCell = {
+              Value = rowIndex.ToString(),
+            }
+          };
+
+          row.CreateCells(grid);
+
+          var absoluteDiff = Evaluator.Evaluate(pushInterpreter, Content.Program, i);
+          var relativeDiff = absoluteDiff / Math.Abs(data.BestResult - data.WorstResult) * 100d;
+
+          var inputArgumentCountDict = ViewHelper.CreateArgumentCountDict();
+          for (var j = 0; j < data.InputArgumentTypes.Length; j++) {
+            var type = data.InputArgumentTypes[j];
+            var offset = inputArgumentCountDict[type];
+            row.Cells[j].Value = ViewHelper.StringifyInput(type, offset, Content.Config.FloatStringFormat, example, Separator);
+            inputArgumentCountDict[type]++;
+          }
+
+          var outputArgumentCountDict = ViewHelper.CreateArgumentCountDict();
+          for (var j = 0; j < data.OutputArgumentTypes.Length; j++) {
+            var type = data.OutputArgumentTypes[j];
+            var offset = outputArgumentCountDict[type];
+
+            // expected
+            row.Cells[data.InputArgumentTypes.Length + j * 2].Value = ViewHelper.StringifyOutput(type, offset, Content.Config.FloatStringFormat, example, Separator);
+
+            // output
+            row.Cells[data.InputArgumentTypes.Length + j * 2 + 1].Value = pushInterpreter.StringifyResult(type, offset);
+
+            outputArgumentCountDict[type]++;
+          }
+
+          row.Cells[data.TotalArgumentCount + 1].Value = absoluteDiff.ToString("0.####");
+          row.Cells[data.TotalArgumentCount + 2].Value = relativeDiff.ToString("0.##") + "%";
+
+          if (absoluteDiff.IsAlmost(data.BestResult)) {
+            for (var j = 0; j < row.Cells.Count; j++) {
+              row.Cells[j].Style.ForeColor = correctExampleFontColor;
+            }
+          }
+
+          grid.Rows.Add(row);
+          pushInterpreter.Reset();
+        }
+      }
+    }
+
+    private void UpdateExamples(ProblemData data) {
+      exampleComboBox.Items.Clear();
+      if (data == null) return;
+
+      var stringRepresentations = data.Examples.Select(e =>
+        string.Join(Separator, e.InputArgs) +
+        exampleSplitter +
+        string.Join(Separator, e.OutputArgs));
+
+      foreach (var str in stringRepresentations) {
+        exampleComboBox.Items.Add(str);
+      }
+    }
+  }
+}
